"""
This to form various bases:
"""

import pickle
from copy import deepcopy as deepcopy


from TwBT import giveBr as giveBr

from LinCombGraphs import Perm as Perm
from LinCombGraphs import Part as Part


"""
The output of loadBT10 is the list BT10 of length 10
The BT10[i] is the list of all brace trees of arity i+1
"""
#Tested
def loadBT10():
    FO = open('BT10','rb')  # Now we can read the file storage
    L = pickle.load(FO) #
    return L


"""
This for storing. After the file Br9 is stored, this 
function is not needed.
"""    
#Tested
def saveBr9():
    BT10 = loadBT10() # we need all lists in  BT10
    Br9 = [ [[]] ] # stuff of arity 1
    for n in range(2,10):
        # getting braces tree of arity n.
        L = []
        for T in BT10[n]:
            L = L + [TT for TT in giveBr(1,T)]
        Br9.append(deepcopy(L))
    pickle.dump(Br9,open('Br9','wb')) # we dump the list Br9 into the file storage
    return []

"""
loadBr9() returns the list of lists.
Br9[n-1] is the list of all brace trees of arity n with exactly 1 neutral vert.
The order of labels is the standard one. 
"""
#Tested
def loadBr9():
    FO = open('Br9','rb')  # Now we can read the file storage
    L = pickle.load(FO) #
    return L

    

"""
genGen Returns a list of all standard Ger words of length n.
"""
        
#VD: On my laptop, it took approx. 10 minutes to verify that the length of genGer(9)
# is factorial(9)

#Tested
def genGer(n):
    words = []
    for j in range(1,n+1):
        for k in Part(n,j):
            kwords = []
            for j in Perm(n):
                word = []
                at = 0
                isWord = True
                for l in k:
                    t = tuple(j[i] for i in range(at, at+l))
                    if not max(t) == t[l-1]:
                        isWord = False
                        break
                    word.append(t)
                    at = at + l
                word = sorted(word)
                if isWord == True and not word in kwords:
                    kwords.append(word)
            words.extend(kwords)
    return words


"""
This function is used to form and then store the list of bases ConvCirc. 
ConvCirc[n-1] is the basis of degree 1 elements in 
BT(n) \otimes_{S_n} Ger(n) 
Note that all Ger-words must have exactly 2 LaLie words.
We go here up to arity 6 (including arity 6).
"""
# Tested using loadConvCirc()
def saveConvCirc():
    BT = loadBT10() # we need all lits BT10
    ConvCirc = [ [[]] ] # this is for arity 1.
    for n in range(2,7):
        L = []
        for w in genGer(n):
            if len(w) == 2:
                for T in BT[n-1]:
                    L.append((T,w))
        ConvCirc.append(deepcopy(L))
    pickle.dump(ConvCirc,open('ConvCirc','wb')) # we dump the list ConvCirc into the file storage
    return []

"""
This function returns the list of bases ConvCirc
"""
#Tested
def loadConvCirc():
    FO = open('ConvCirc','rb')  # Now we can read the file storage
    L = pickle.load(FO) 
    return L
    
"""
This functions forms and stores the list of bases ConvBul.
ConvBul[n-1] is the basis of degree 1 elements in 
Br(n) \otimes_{S_n} Ger(n)
for which each brace tree has exactly 1 neutral vertex.
We do this up to arity 6 (including 6). 
"""
#Tested using loadConvBul()
def saveConvBul():
    Br = loadBr9() # we need Br9
    ConvBul = [ [[]] ] # this is for arity 1.
    for n in range(2,7):
        L = []
        for w in genGer(n):
            if len(w) == 1:
                for T in Br[n-1]:
                    L.append((T,w))
        ConvBul.append(deepcopy(L))
    pickle.dump(ConvBul,open('ConvBul','wb')) # we dump the list ConvBul into the file storage
    return []



"""
This function returns the list of bases ConvBul
"""
#Tested
def loadConvBul():
    FO = open('ConvBul','rb')  # Now we can read the file storage
    L = pickle.load(FO) 
    return L
    
